package com.company.treedatagridsum.app;

import com.company.treedatagridsum.entity.BalanceSheet;
import io.jmix.core.DataManager;
import io.jmix.core.SaveContext;
import jakarta.persistence.EntityManager;
import jakarta.persistence.PersistenceContext;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

@Component("sum_TreeGridServiceBean")
public class TreeGridServiceBean {
    @PersistenceContext
    private EntityManager em;
    @Autowired
    private DataManager dataManager;

    @Transactional
    public void createTestData(){

        //create
//        if(balanceSheetsDc.getItems()!=null && balanceSheetsDc.getItems().size()>0){
            SaveContext saveContext = new SaveContext();

            BalanceSheet balanceSheet10 = dataManager.create(BalanceSheet.class);
            balanceSheet10.setName("Assets");
            saveContext.saving(balanceSheet10);

            BalanceSheet balanceSheet20 = dataManager.create(BalanceSheet.class);
            balanceSheet20.setName("Fixed assets");
            balanceSheet20.setParentHead(balanceSheet10);
            saveContext.saving(balanceSheet20);

            BalanceSheet balanceSheet21 = dataManager.create(BalanceSheet.class);
            balanceSheet21.setName("Plant and machinery");
            balanceSheet21.setParentHead(balanceSheet20);
            balanceSheet21.setAmountCy(2000.0);
            saveContext.saving(balanceSheet21);

            BalanceSheet balanceSheet30 = dataManager.create(BalanceSheet.class);
            balanceSheet30.setName("Current assets");
            balanceSheet30.setParentHead(balanceSheet10);
            saveContext.saving(balanceSheet30);

            BalanceSheet balanceSheet31 = dataManager.create(BalanceSheet.class);
            balanceSheet31.setName("Cash in hand");
            balanceSheet31.setParentHead(balanceSheet30);
            balanceSheet31.setAmountCy(1500.0);
            saveContext.saving(balanceSheet31);

            BalanceSheet balanceSheet32 = dataManager.create(BalanceSheet.class);
            balanceSheet32.setName("Accounts receivable");
            balanceSheet32.setParentHead(balanceSheet30);
            balanceSheet32.setAmountCy(3000.0);
            saveContext.saving(balanceSheet32);

            dataManager.save(saveContext);
   //     }

    }


    public void deleteData(){
        //delete existing
        em.createNativeQuery("delete from SUM_BALANCE_SHEET").executeUpdate();

    }
}