package com.company.treedatagridsum.view.balancesheet;

import com.company.treedatagridsum.app.TreeGridServiceBean;
import com.company.treedatagridsum.entity.BalanceSheet;

import com.company.treedatagridsum.view.main.MainView;

import com.vaadin.flow.component.grid.ItemDoubleClickEvent;
import com.vaadin.flow.router.Route;
import io.jmix.core.DataManager;
import io.jmix.core.SaveContext;
import io.jmix.flowui.kit.action.ActionPerformedEvent;
import io.jmix.flowui.model.CollectionContainer;
import io.jmix.flowui.model.CollectionLoader;
import io.jmix.flowui.view.*;
import jakarta.persistence.EntityManager;
import jakarta.persistence.PersistenceContext;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.*;
import java.util.stream.Collectors;

@Route(value = "balanceSheets", layout = MainView.class)
@ViewController("sum_BalanceSheet.list")
@ViewDescriptor("balance-sheet-list-view.xml")
@LookupComponent("balanceSheetsDataGrid")
@DialogMode(width = "50em")
public class BalanceSheetListView extends StandardListView<BalanceSheet> {
    @Autowired
    private TreeGridServiceBean treeGridServiceBean;
    @ViewComponent
    private CollectionLoader<BalanceSheet> balanceSheetsDl;
    @ViewComponent
    private CollectionContainer<BalanceSheet> balanceSheetsDc;
    @Autowired
    private DataManager dataManager;

    @Subscribe
    public void onBeforeShow(final BeforeShowEvent event) {
        //treeGridServiceBean.deleteData();

        treeGridServiceBean.createTestData();

        calcTreeGrid();
    }



    /*
    private void calcTotalInTreeGrid(){
        // Iterate over each parent row
        balanceSheetDc.getItems().forEach(parentItem -> {
            final MutableDouble sum = new MutableDouble(0.0);

            // Retrieve child rows for the current parent row
            balanceSheetDc.getMutableItems().stream()
                    .filter(childItem -> Objects.equals(childItem.getParentHead(), parentItem))
                    .forEach(childItem -> {
                        // Calculate the sum using the desired column(s) values
                        double value = childItem.getAmountCy();
                        sum.add(value);
                    });

            // Set the sum value on the parent row
            parentItem.setAmountCy(sum.doubleValue());
        });

    }

    public class MutableDouble {
        private double value;

        public MutableDouble(double value) {
            this.value = value;
        }

        public void add(double value) {
            this.value += value;
        }

        public double doubleValue() {
            return value;
        }
    }
*/


    private void calcTreeGrid(){
        if(balanceSheetsDc.getItems()!=null && balanceSheetsDc.getItems().size()>0) {
    // Create a map to store the child items for each parent item
            Map<BalanceSheet, List<BalanceSheet>> childItemsMap = new HashMap<>();
    // Create a map to store the sum for each parent item
            Map<BalanceSheet, Double> sumMap = new HashMap<>();

    // Iterate over each parent row
            balanceSheetsDc.getItems().forEach(parentItem -> {
                double sum = 0.0;

                // Retrieve child rows for the current parent row
                List<BalanceSheet> childItems = balanceSheetsDc.getMutableItems().stream()
                        .filter(childItem -> Objects.equals(childItem.getParentHead(), parentItem))
                        .collect(Collectors.toList());

                // Calculate the sum using the desired column(s) values
                sum = childItems.stream().filter(f-> f.getAmountCy()!=null).mapToDouble(BalanceSheet::getAmountCy).sum();

                // Set the sum value on the parent row
                parentItem.setAmountCy(sum);

                // Update the sum in the map
                sumMap.put(parentItem, sum);
            });

            // Restore the original child item values
            childItemsMap.forEach((parentItem, childItems) -> {
                balanceSheetsDc.getMutableItems().removeAll(childItems);
                balanceSheetsDc.getMutableItems().addAll(childItems);
            });
        }
    }



/*
    private void calcTreeGrid(){
        // Assuming you have a Jmix DataContainer named "balanceSheetDc" and the parent field is "ParentHead"

// Create a map to store the original child item values and their index positions
        Map<BalanceSheet, List<BalanceSheet>> childItemsMap = new HashMap<>();
        Map<BalanceSheet, Integer> childItemIndicesMap = new HashMap<>();

// Store the original child items and their index positions for each parent item
        balanceSheetsDc.getItems().forEach(parentItem -> {
            List<BalanceSheet> childItems = balanceSheetsDc.getMutableItems().stream()
                    .filter(childItem -> Objects.equals(childItem.getParentHead(), parentItem))
                    .collect(Collectors.toList());

            childItemsMap.put(parentItem, new ArrayList<>(childItems));

            for (int i = 0; i < childItems.size(); i++) {
                childItemIndicesMap.put(childItems.get(i), i);
            }
        });

// Create a temporary list to hold the updated parent items
        List<BalanceSheet> updatedParentItems = new ArrayList<>();

// Calculate the sum for each parent item
        balanceSheetsDc.getMutableItems().forEach(parentItem -> {
            List<BalanceSheet> childItemsCopy = new ArrayList<>(childItemsMap.get(parentItem));

            // Calculate the sum using the desired column(s) values
            double sum = childItemsCopy.stream().filter(f-> f.getAmountCy()!=null).mapToDouble(BalanceSheet::getAmountCy).sum();

            // Set the sum value on the parent row
            parentItem.setAmountCy(sum);

            // Add the updated parent item to the temporary list
            updatedParentItems.add(parentItem);
        });

// Update the parent items in the data container
        balanceSheetsDc.setItems(updatedParentItems);

// Restore the original child item values and their positions
        balanceSheetsDc.getItems().forEach(parentItem -> {
            List<BalanceSheet> childItems = new ArrayList<>(childItemsMap.get(parentItem));
            Integer[] indices = childItemIndicesMap.entrySet().stream()
                    .filter(entry -> childItems.contains(entry.getKey()))
                    .map(Map.Entry::getValue)
                    .toArray(Integer[]::new);

            if (indices.length == childItems.size()) {
                balanceSheetsDc.getMutableItems().removeAll(childItems);
                for (int i = 0; i < indices.length; i++) {
                    balanceSheetsDc.getMutableItems().add(indices[i] + i, childItems.get(i));
                }
            }
        });

    }
*/



}